#!c:/perl/bin/perl

#script copywrite Stephen C-E 2005

#Path to map images
$path='..\\htdocs\\servermonitor\\maps';
$urlpath='/servermonitor/maps';

#the url for the server passwords
$passurl = 'http://ut2004.titaninternet.co.uk/vbb/showthread.php?t=2261';

#ons, iTDM
@servername = ("Titan 32 Player Onslaught", "Titan Chillout Server");
#External IP addresses (for display purposes on the page)
@server = ("217.77.176.198","217.77.176.199");
#Server Query IP addresses - if the HTTP server is on a lan with the game server you should use the internal address
@intserver = ("217.77.176.198","217.77.176.199");
#webadmin userids and passwords, webadmin port
@webadmin=("removedloginname","removedloginname");
@webadminpass=("removedpassword","removedpassword");
@intserverwebport=("1234","1234");

#epic stats ID for the servers
@serverstats = (8582195,11999163);
@gameport = (7777,7777);

$refreshtime = "30";
$queryport = 10;
$timeout = 5;
$title = "Titan UT2004 Server Query";
#$script = "$ENV{SCRIPT_URI}";

###################################################
#
# Server Query Intervals and stored info locations
#
###################################################

#saved server gamespy results
$serverfile = 'saved_data\\serverfile#.txt';
#Minimum time (seconds) before the server will be queried again by gamespy protocol
# regardless of number of clients asking for it
$serverqueryinterval = 25;

#saved mutators info from ut2004 query
$mutsfile = 'saved_data\\mutsfile#.txt';
#Minimum time (seconds) before the server will be queried again by ut2004 protocol 
# regardless of number of clients asking for it
$mutqueryinterval = 240;

#saved chat from webadmin
$chatfile = 'saved_data\\chatfile#.txt';
#Minimum time (seconds) before the webadmin chat will be queried again
# regardless of number of clients asking for it
$chatqueryinterval = 35;

#saved epic stats from their site
$epicfile = 'saved_data\\statsfile#.txt';
#Minimum time (seconds) before the Epic stats site will be queried again
# regardless of number of clients asking for it
$epicqueryinterval = 240;

#get command line stuff
my @envs;
my @qs = split(/&/,$ENV{'QUERY_STRING'});
foreach $part (@qs) {
	my @temp = split(/=/,$part);
	@envs{$temp[0]}=$temp[1];
}

#globally required vars
$which=int($envs{"server"});
$timenow = time;

use Socket;
use Sys::Hostname;
use Cwd;
use LWP::Simple;
use LWP;
use IO::Socket::INET;
require MIME::Base64;
$basedir = getcwd;

############################################################

# Unused stuff:

# bForceRespawn\False\
# bWeaponStay\True
# bAllowBehindView\False\
# bAllowWeaponThrowing\True

#############################################################
# Main processing
#############################################################

&query_server();

&convert_for_display();

if ($envs{"type"} eq "js") {
#output javascript source
	&javascript();
}
else {
#output web page
	&startpage();
	&query_server_muts();
	&display2();
	print getchat();
	&getstats();
	&endpage();
}
exit;

# This example function can be called to embed server output into a web page
# <script type="text/javascript" src="thiscript.pl?server=0&type=js" />
sub javascript(){
print "Content-type: text/javascript\n\n";
$jsout = "<table class='servermonitor'><tr class='mapname'><td colspan='2'>$data{maptitle}</td></tr>";
$jsout .= "<tr class='mapname'><td colspan='2'>$gamestatus</td></tr>";
my $redfrags=0;
my $bluefrags=0;
my $redplayers=0;
my $blueplayers=0;
my $redt32=0;
my $bluet32=0;

foreach $line (@players) {
 @foo = split(/MYSEPAR/,$line);
 if ($foo[2] eq "0") {
	$redfrags += $foo[1];
	$redplayers++;
	$_ = $foo[0];
	if(m/t32/i){$redt32++;}
 }
 else {
 	$bluefrags += $foo[1];
	$blueplayers++;
	$_ = $foo[0];
	if(m/t32/i){$bluet32++;}
 }
}

$jsout .= qq(<tr><td class='red'>Score</td><td class='red'>$redfrags</td></tr>);
$jsout .= qq(<tr><td class='red'>Players</td><td class='red'>$redplayers</td></tr>);
$jsout .= qq(<tr><td class='blue'>Score</td><td class='blue'>$bluefrags</td></tr>);
$jsout .= qq(<tr><td class='blue'>Players</td><td class='blue'>$blueplayers</td></tr>);
$jsout .= qq(<tr><td class='t32s'>T32\'s</td><td><span class='red'>$redt32</span>/<span class='blue'>$bluet32</span</td></tr>);
$jsout .= qq(<tr><td class='time'>Time Remain</td><td class='time'>$data{RemainingTime}</td></tr>);
$jsout .= qq(<tr><td class='ssettings_item'>Players:</td><td class='ssettings_value'>$data{numplayers}/$data{maxplayers}</td></tr>);
$jsout .= qq(<tr><td colspan='2' class='bots'>$botline</td></tr>);
$jsout .= qq(<tr><td class='ssettings_item'>Spectators:</div></td><td class='ssettings_value'>$data{NumSpectators}/$data{MaxSpectators}</td></tr>);
$jsout .= "<tr><td colspan='2' class='joingame'><a href='ut2004://$server[$which]:$gameport[$which]'>Join the action</a></td></tr>";
$jsout .= "<\/table>";

print jsconvert($jsout);

}

sub jsconvert(){
	my $temp = shift;
	$temp =~ s/\n//gs;
	$temp =~ s/\'/\\\'/g;
	return "document.writeln ('$temp');\n";
}


sub startpage
{
print "Content-type: text/html\n\n";
print qq
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
	<HEAD>
	<title>$servername[$which] Server Status</title>
		<LINK REL="StyleSheet" HREF="/servermonitor/monitor.css" TYPE="text/css">
	</HEAD>
;
}


sub endpage
{
	if (defined $envs{forceRefresh}) {
		my $debugline = "<div style='visibility: hidden; display: none;'>$response</div>";
	}
	else {
		my $debugline = "";
	}

	print qq
	<script type="text/javascript">
	<!--
	var t = $refreshtime;
	function r(){
		if (--t==0)location.reload();
		else { 
			setTimeout("r()",1000);
			window.status="Refreshing in "+t;
			if (x=document.getElementById("countdown")) x.innerHTML = t;
		}
	}
	r();
	</script>
	$mydebugline
	</body>
	</html>
	;
}

#gets the chat from the webadmin
sub getchat(){

	if ($data{password} eq "") {
		my $logfile = $chatfile;
		$logfile =~ s/#/$which/;
		if (-e "$logfile") {
			open( FILE, "$logfile" ); 
			$oldtime = <FILE>;
			if (!defined $envs{forceRefresh} && ($timenow - int($oldtime)) < $chatqueryinterval) {
				while( <FILE> ) { 
						$chat .= $_;
				} 
			}
			close( FILE );
		}
		if (defined $chat) {
			return $chat;
		}
		else {
			my $browser = LWP::UserAgent->new;
			my $login = MIME::Base64::encode( "$webadmin[$which]:$webadminpass[$which]", '' );
			my @ns_headers = ('Authorization' => "Basic $login");
			my $url ="http://$intserver[$which]:$intserverwebport[$which]/ServerAdmin/current_console_log";
			my $response = $browser->get($url, @ns_headers);

			if ($response->is_success) {
				$chat= $response->content;
				$chat =~ s/.*?<\/table>//s;
				$chat =~ s/.*?<br \/>/<table align='center' width='600' class='chat'><tr><td class='heading' align='center'>In-Game Public Chat<\/td><\/tr><tr><td>/s;
				$chat =~ s/<a name="END".*/<\/td><\/tr><\/table>/s;
				$chat =~ s/&gt; \(None\).*?<br>//g;
				if (!defined $envs{forceSpectators}) {$chat =~ s/&gt; \[.*?<br>//g;}
				
				open(OUTFILE,">$logfile") || &error("Cannot Open the saved chatfile");
				flock(OUTFILE, 2);
				print OUTFILE "$timenow\n$chat";
				flock(OUTFILE, 8);
				close( OUTFILE );
				return $chat;
			} else{
				return "<table align='center' width='600' class='chat'><tr><td class='heading' align='center'>In-Game Public Chat<\/td><\/tr><tr><td>** Error Retrieving data from server **<\/td><\/tr></table>;"#<div style='visibility: hidden; display: none;>Error: ". $response->startpage('WWW-Authenticate') ."<br /><br />". $response->status_line;
			}
		}
	} 
	else {
	  return "<table align='center' width='600' class='chat'><tr><td class='heading' align='center'>In-Game Public Chat<\/td><\/tr><tr><td>Locked server chat hidden<\/td><\/tr></table>";
	}
}

sub query_server_muts
{
	my $logfile = $mutsfile;
	$logfile =~ s/#/$which/;
	if (-e "$logfile") {
		open( FILE, "$logfile" ); 
		$oldtime = <FILE>;
		if (!defined $envs{forceRefresh} && ($timenow - int($oldtime)) < $serverqueryinterval) {
			while( <FILE> ) { 
					$muts .= $_;
			} 
		}
		close( FILE );
	}
	if (defined $muts) {
		return;
	}
	else {
		$queryport = $gameport[$which] + 1;
		$MySocket=new IO::Socket::INET->new(PeerPort=>$queryport,
				Proto=>'udp',
				PeerAddr=>$intserver[$which]);
		$msg="\x78\x00\x00\x00\x03";
		$MySocket->send($msg);
		$MySocket->recv($text,2048);
		$block .= $text;
		$MySocket->recv($text,2048);
		$block .= $text;
		$MySocket->close;
		@words = ($block =~ /Mutator\x00.(.*?)\x00/gs);
		if (defined(@words)) {
			$muts=(join ", ", @words);
			open(OUTFILE,">$logfile") || &error("Cannot Open the Server Muts file");
			flock(OUTFILE, 2);
			print OUTFILE "$timenow\n$muts";
			flock(OUTFILE, 8);
			close( OUTFILE );
		}
	}
}

sub query_server
{
	my $logfile = $serverfile;
	$logfile =~ s/#/$which/;
	if (-e "$logfile") {
		open( FILE, "$logfile" ); 
		$oldtime = <FILE>;
		if (!defined $envs{forceRefresh} && ($timenow - int($oldtime)) < $serverqueryinterval) {
			while( <FILE> ) { 
					$response .= $_;
			} 
		}
		close( FILE );
	}
	if (defined $response) {
		return $chat;
	}
	else {
		$queryport = $gameport[$which] + $queryport;
		$ipaddr = inet_aton($intserver[$which]);
		$portaddr = sockaddr_in($queryport, $ipaddr);

		$query = "\\status\\\\game_property\\bForceRespawn\\\\game_property\\GameSpeed\\";
		$query .= "\\game_property\\MaxSpectators\\\\game_property\\NumSpectators\\\\game_property\\bLoggingGame\\\\game_property\\ElapsedTime\\";
		$query .= "\\level_property\\Author\\\\game_property\\gamestats\\\\game_property\\goalscore\\\\game_property\\timelimit\\";
		$query .= "\\game_property\\minplayers\\\\game_property\\bWeaponStay\\\\game_property\\bGameEnded\\\\game_property\\bWaitingToStartMatch\\";
		$query .= "\\game_property\\GameDifficulty\\\\game_property\\NumBots\\\\game_property\\bEnableStatLogging\\";
		$query .= "\\level_property\\Description\\\\game_property\\RemainingTime\\";
		$query .= "\\game_property\\bAllowBehindView\\\\game_property\\bAllowWeaponThrowing\\\\game_property\\bOverTime\\";

		socket(SOCKET, PF_INET, SOCK_DGRAM, getprotobyname 'udp') || &error("Unable to create socket");
		send(SOCKET, $query, 0, $portaddr) || &error("Unable to send data to the UT server");
		vec($rin, fileno(SOCKET), 1) = 1;
		while (($response !~ /\\final\\$/) && select($rout = $rin, undef, undef, $timeout))
		 {
		 $svrportaddr = recv(SOCKET,$getback,2048,0) || &error("Sorry, unable to receive data from the server, The server could be down");
		 $response = $response . $getback;
		 }
		close(SOCKET);
		open(OUTFILE,">$logfile") || &error("Cannot Open the Server log file");
		flock(OUTFILE, 2);
		print OUTFILE "$timenow\n$response";
		flock(OUTFILE, 8);
		close( OUTFILE );
		if ($response eq "") {&error("No response from the server. It is most likely that a new map is loading.");}
	}
}

sub convert_for_display
{
@botlevels = ("Novice","Average","Experienced","Skilled","Adept","Masterful","Inhuman","Godlike");

@raw = split(/\\/,$response);

foreach $bit1 (@raw)
 {
 if ($bit2)
  {
  $data{$bit2} = $bit1;
  if ($bit2 eq "queryid")
   {
   ($null,$dec) = split(/\./,$bit1);
   $packetcount++;
   if ($dec > $maxpackets) {$maxpackets = $dec;}
   }
  if ($bit2 =~ /^player\_/)
   {
   ($null,$dec) = split(/\_/,$bit2);
   if ($dec >= $countplayers) {$countplayers = $dec;}
   }
  $bit1 = "";
  }
 $bit2 = $bit1;
 }
if ($maxpackets > $packetcount)
 {
 &error("There was a glitch communicating with the server.");
 }


$data{GameSpeed} = sprintf("%.2f",$data{GameSpeed});

if ($data{bWeaponStay} eq "True") {$data{bWeaponStay} = "Yes";}
elsif ($data{bWeaponStay} eq "False") {$data{bWeaponStay} = "No";}

if ($data{bForceRespawn} eq "True") {$data{bForceRespawn} = "Yes";}
elsif ($data{bForceRespawn} eq "False") {$data{bForceRespawn} = "No";}

if ($data{bAllowBehindView} eq "True") {$data{bAllowBehindView} = "Yes";}
else {$data{bAllowBehindView} = "No";}

if ($data{bAllowWeaponThrowing} eq "True") {$data{bAllowWeaponThrowing} = "Yes";}
else {$data{bAllowWeaponThrowing} = "No";}

if ($data{bEnableStatLogging} eq "True") {$data{bEnableStatLogging} = "Yes";}
elsif ($data{bEnableStatLogging} eq "False") {$data{bEnableStatLogging} = "No";}

if ($data{password} eq "0") {$data{password} = "";}
else {$data{password} = "<a class='password' href='$passurl' target='_blank'>The server is currently passworded</a>";}

$data{GameDifficulty} = int($data{GameDifficulty});
if ($data{minplayers})
 {
 if ($data{bWaitingToStartMatch } eq "True") {$data{NumBots} = $data{minplayers};}
# $playersfoot = "Plus $data{NumBots} Bots of $botlevels[$data{GameDifficulty}] skill";
 $botline = "$data{NumBots} $botlevels[$data{GameDifficulty}] bots";
 }
else {$botline = "No Bots";}

if ($countplayers ne "")
 {
 for ($i = 0; $i <= $countplayers; $i++)
  {
  $player = "player_" . $i;
  $frags = "frags_" . $i;
  $ping = "ping_" . $i;
  $team = "team_" . $i;
  $line = "$data{$player}MYSEPAR$data{$frags}MYSEPAR$data{$team}MYSEPAR$data{$ping}";
  push(@players,$line);
  }
 $sort = 1;
 @players = sort {(split(/MYSEPAR/, $b))[$sort] <=> (split(/MYSEPAR/, $a))[$sort];} @players;
 }

if ($data{goalscore} eq "0") {$data{goalscore} = "Unlimited";}

if ($data{ElapsedTime}) {$gamestatus = "Playing";}
elsif ($data{bWaitingToStartMatch} eq "True") {$gamestatus = "Waiting to start";}
elsif ($data{bGameEnded} eq "True") {$gamestatus = "Game just ended";}

if ($data{bOverTime} eq "True") {$gamestatus = "In Overtime";}

@ElapsedTime = localtime($data{ElapsedTime});
$ElapsedTime[2]--;
if ($ElapsedTime[0]<10) {$ElapsedTime[0] = "0$ElapsedTime[0]";};
if ($ElapsedTime[1]<10) {$ElapsedTime[1] = "0$ElapsedTime[1]";};
if ($ElapsedTime[2] > 0) {$data{ElapsedTime} = "$ElapsedTime[2]:$ElapsedTime[1]:$ElapsedTime[0]";}
else {$data{ElapsedTime} = "$ElapsedTime[1]:$ElapsedTime[0]";}

@RemainingTime = localtime($data{RemainingTime});
$RemainingTime[2]--;
if ($RemainingTime[0]<10) {$RemainingTime[0] = "0$RemainingTime[0]";};
if ($RemainingTime[1]<10) {$RemainingTime[1] = "0$RemainingTime[1]";};
if ($RemainingTime[2] > 0) {$data{RemainingTime} = "$RemainingTime[2]:$RemainingTime[1]:$RemainingTime[0]";}
else {$data{RemainingTime} = "$RemainingTime[1]:$RemainingTime[0]";}


if ($data{timelimit} eq "0") {$data{timelimit} = "Unlimited";}
else
 {
 $data{timelimit} = $data{timelimit} * 60;
 @timelimit = localtime($data{timelimit});
 $timelimit[2]--;
 if ($timelimit[1]<10) {$timelimit[1] = "0$timelimit[1]";};
 if ($timelimit[2] > 0) {$data{timelimit} = "$timelimit[2]:$timelimit[1]:00";}
 else {$data{timelimit} = "$timelimit[1]:00";}
 }
 $mapimg = getimg($data{gametype}, $data{mapname})
}


sub error
{
	$errortext = $_[0];
	&startpage();
	print qq!
	<CENTER><H1>Sorry - the information is currently unavailable...</H1></CENTER>
	<HR WIDTH=75% ALIGN=Center>
	<BR>
	<BR><CENTER><B>
	<BR>$errortext
	<BR><BR>
	The page will refresh in $refreshtime seconds.
	<BR></B></CENTER>
	!;
	&endpage();
	exit;
}


############################################################################
#
# Retrieve a map image for the current game - jpg, gif or .png
#
############################################################################

sub getimg()
{
	my $game = shift;
	my $map = shift;

	my $printpath="$urlpath/$game/$map/";
	my @imglist = getlist("$path\\$game\\$map");
	if ($#imglist==-1) {
		$printpath="$urlpath/$game/";
		@imglist = getlist("$path\\$game")
	}

	return  $printpath.$imglist[int(rand($#imglist-1))];
}

sub getlist(){
	my ($path) = shift;

	if (-e $path) {
		chdir( $path ); 
		my ( @a ) = <*.jpg>; 
		my ( @b ) = <*.gif>; 
		my ( @c ) = <*.png>; 
		chdir( $basedir ); 
		return ((@a, @b, @c));
	}
	else {
		my @temp;
		return (@temp);
	}
}

sub round {
    my($number) = shift;
    return int($number + .5);
}

############################# end of get image

sub getstats(){

		my $logfile = $epicfile;
	$logfile =~ s/#/$which/;
	if (-e "$logfile") {
		open( FILE, "$logfile" ); 
		$oldtime = <FILE>;
		if (!defined $envs{forceRefresh} && ($timenow - int($oldtime)) < $epicqueryinterval) {
			while( <FILE> ) { 
					$doc .= $_;
			} 
		}
		close( FILE );
	}
	if (defined $doc) {
		print $doc;
	}
	else {
		$doc = get 'http://ut2004stats.epicgames.com/serverstats.php?server='.$serverstats[$which];
		if ((defined $doc) && ($doc =~ /minutes/s)){
			$doc =~ s/<\!doctype.*minutes//s;
			$doc =~ s/<.*?<table/<table width=\"600\" class=\"stats\" align=\"center\"/s;
			$doc =~ s/<\/table.*/<\/table>/s;
			$doc =~ s/<a.*mapstats.*>(.*)<\/a>/$1/g;
			$doc =~ s/href=\"(.*?)\.php/href=\"http:\/\/ut2004stats.epicgames.com\/$1.php/g;
			$doc =~ s/>Date</>Date and time as reported by Epic</;
			#$doc =~ s/.*Match Type.*//;
			#$doc =~ s/.*Onslaught.*//g;
			#$doc =~ s/an="5"/an="4"/;
			$doc =~ s/([gky]") align="center"/$1/g;
			$doc =~ s/\n//gs;
			print $doc;
		}
		else {$doc="\n";}
		open(OUTFILE,">$logfile") || &error("Cannot Open File the Epic Data file");
		flock(OUTFILE, 2);
		print OUTFILE "$timenow\n$doc";
		flock(OUTFILE, 8);
		close( OUTFILE );
	}
}

sub display2(){
print qq
	<body>
<table cellpadding='0' cellspacing='0' border='0' align='center' class='drpServerSelectTable' width='600'>
	<tr>
		<td class='refresh'>Page refreshing in <span id='countdown'>&nbsp;</span></td>
		<td class='drpServerSelectItm' align='right'><span class='drpServerSelectTxt'>Select Server</span>
					<select name='serverdrop' class='drpServerSelectItm' onChange='document.location.href=document.location.pathname + "?server=" + this.selectedIndex;' id='drpServerSelectItm'>
;
my $i=0;
foreach $serv (@servername) {
	print "<option ".(($i++ == $which)?"selected ":"").">$serv</option>\n";
}

if ($data{password} ne "") {
	$passline = "<tr><td colspan='2' class='password'><div class='password'><span class='password'>$data{password}</span></div></td></tr>"
}
else {
	$passline = "";
}

print qq
				</select></td></tr>
</table>
<table width='500' cellpadding='0' cellspacing='0' border='0' align='center' class='main'>
	<tr><td colspan='2' class='header'><div class='header'><div style="float:center"><img src="/servermonitor/serverstatusheader.jpg"></div></div></td></tr>
	<tr><td colspan='2' class='servername'><div class='servername'>$data{hostname}</div></td></tr>
	<tr><td colspan='2' class='ipaddress'><div class='ipaddress'>Server Address: <span class='ipaddress'><a href='ut2004://$server[$which]:$gameport[$which]' class='ipaddress'>ut2004://$server[$which]:$gameport[$which]</a></span></div></td></tr>
	$passline
	<tr><td colspan='2' class='mappic'><div class='mappic'><a href='http://ut2004.titaninternet.co.uk/' target='_new'><img src='$mapimg' width='495' height='248' alt='Visit ut2004.titaninternet.co.uk!' border='0' class='mappic'></a></div></td></tr>
	<tr><td colspan='2' class='mapname'><div class='mapname'>Current Map: <a href='#info' class='mapnamei'>$data{maptitle}
;
if ($data{maptitle} ne $data{mapname}) { print " - $data{mapname}"}
print qq
					</a>
				</div>
			</td>
		</tr>
		<tr>
			<td width='50%' class='playerlist' height='100%'>
				<table cellpadding='0' cellspacing='0' border='0' width='100%' height='100%' class='playerlist_red'>
					<tr>
<td colspan='3' class='pteam_header_red'><div class='pteam_header_red'>Red Team</div></td>
</tr>
<tr>
<td class='pteam_label_name'><div class='pteam_label'>Player Name</div></td>
<td class='pteam_label_frag'><div class='pteam_label'>Score</div></td>
<td class='pteam_label_ping'><div class='pteam_label'>Ping</div></td>
;
					
foreach $line (@players)
 {
 @foo = split(/MYSEPAR/,$line);
 if ($foo[2] eq "0") {
print qq
</tr><tr>
   <td class='pname'><div class='pname_red'>$foo[0]</div></td>
   <td class='pfrag'><div class='pfrag_red'>$foo[1]</div></td>
   <td class='pping'><div class='pping_red'>$foo[3]</div></td>
</tr><tr>
;
 }
 }
print qq
</tr>

				</table>
			</td>
			<td width='50%' class='playerlist' height='100%'>
				<table cellpadding='0' cellspacing='0' border='0' width='100%' height='100%' class='playerlist_blue'>
					<tr>
<td colspan='3' class='pteam_header_blue'><div class='pteam_header_blue'>Blue Team</div></td>
</tr>
<tr>
<td class='pteam_label_name'><div class='pteam_label'>Player Name</div></td>
<td class='pteam_label_frag'><div class='pteam_label'>Score</div></td>
<td class='pteam_label_ping'><div class='pteam_label'>Ping</div></td>
;
					
foreach $line (@players)
 {
 @foo = split(/MYSEPAR/,$line);
 if ($foo[2] eq "1") {
print qq
</tr><tr>
   <td class='pname'><div class='pname_blue'>$foo[0]</div></td>
   <td class='pfrag'><div class='pfrag_blue'>$foo[1]</div></td>
   <td class='pping'><div class='pping_blue'>$foo[3]</div></td>
</tr><tr>
;
 }
 }
print qq
</tr>

				</table>			
			</td>
		<tr>
			<td width='50%' class='serversettings_header'>
				<table cellpadding='0' cellspacing='0' border='0' width='100%' height='100%' class='serversettings'>
					<tr>
<td colspan='2' class='sset_header'><div class='sset_header'>Server Settings</div></td>
</tr>
<tr>
   <td class='ssettings_item'><div class='ssettings_item'>Cur. Players</div></td>
   <td class='ssettings_value'><div class='ssettings_value'>$data{numplayers}</div></td>
</tr><tr>
   <td class='ssettings_item'><div class='ssettings_item'>Max. Players</div></td>
   <td class='ssettings_value'><div class='ssettings_value'>$data{maxplayers}</div></td>
</tr><tr>
   <td class='ssettings_item'><div class='ssettings_item'>Min. Players</div></td>
   <td class='ssettings_value'><div class='ssettings_value'>$data{minplayers}</div></td>
</tr><tr>
   <td class='ssettings_item'><div class='ssettings_item'><nobr>Cur. Spectators</nobr></div></td>
   <td class='ssettings_value'><div class='ssettings_value'>$data{NumSpectators}</div></td>
</tr><tr>
   <td class='ssettings_item'><div class='ssettings_item'><nobr>Max. Spectators</nobr></div></td>
   <td class='ssettings_value'><div class='ssettings_value'>$data{MaxSpectators}</div></td>
</tr><tr>
   <td class='ssettings_item'><div class='ssettings_item'>Admin Name</div></td>
   <td class='ssettings_value'><div class='ssettings_value'>$data{AdminName}</div></td>
</tr><tr>
   <td class='ssettings_item'><div class='ssettings_item'>Admin Email</div></td>
   <td class='ssettings_value'><div class='ssettings_value'><a href='mailto:$data{AdminEMail}' class='adminemail'>$data{AdminEMail}</a></div></td>
</tr><tr>
   <td class='ssettings_item'><div class='ssettings_item'>Game Version</div></td>
   <td class='ssettings_value'><div class='ssettings_value'>$data{gamever}</div></td>
</tr><tr>
   <td class='ssettings_item'><div class='ssettings_item'>Min Version</div></td>
   <td class='ssettings_value'><div class='ssettings_value'>$data{minnetver}</div></td>
</tr><tr>
<td height='100%'><img src='/servermonitor/clear.gif' width='100' height='1' alt='' border='0'></td>
<td width='100%'><img src='/servermonitor/clear.gif' width='1' height='1' alt='' border='0'></td>
</tr>

				</table>
			</td>
			<td width='50%' class='gamesettings_header'>
				<table cellpadding='0' cellspacing='0' border='0' width='100%' height='100%' class='gamesettings'>
					<tr>
<td colspan='2' class='sset_header'><div class='sset_header'>Game Settings</div></td>
</tr>
<tr>
   <td class='ssettings_item'><div class='ssettings_item'>Map File</div></td>
   <td class='ssettings_value'><div class='ssettings_value'>$data{mapname}</div></td>
</tr><tr>
   <td class='ssettings_item'><div class='ssettings_item'>Map Name</div></td>
   <td class='ssettings_value'><div class='ssettings_value'>$data{maptitle}</div></td>
</tr><tr>
   <td class='ssettings_item'><div class='ssettings_item'>Game Type</div></td>
   <td class='ssettings_value'><div class='ssettings_value'>$data{gametype}</div></td>
</tr><tr>
   <td class='ssettings_item'><div class='ssettings_item'>Goal Score</div></td>
   <td class='ssettings_value'><div class='ssettings_value'>$data{goalscore}</div></td>
</tr><tr>
   <td class='ssettings_item'><div class='ssettings_item'>Status</div></td>
   <td class='ssettings_value'><div class='ssettings_value'>$gamestatus</div></td>
</tr><tr>
   <td class='ssettings_item'><div class='ssettings_item'><nobr>Round Time Limit</nobr></div></td>
   <td class='ssettings_value'><div class='ssettings_value'>$data{timelimit}</div></td>
</tr><tr>   
	<td class='ssettings_item'><div class='ssettings_item'><nobr>Round Time Remaining</nobr></div></td>
   <td class='ssettings_value'><div class='ssettings_value'>$data{RemainingTime}</div></td>
</tr><tr>
   <td class='ssettings_item'><div class='ssettings_item'><nobr>Match Time Elapsed</nobr></div></td>
   <td class='ssettings_value'><div class='ssettings_value'>$data{ElapsedTime}</div></td>
</tr><tr>
	<td class='ssettings_item'><div class='ssettings_item'>Bots</div></td>
   <td class='ssettings_value'><div class='ssettings_value'>$botline</div></td>
</tr><tr>
<td height='100%'><img src='/servermonitor/clear.gif' width='100' height='1' alt='' border='0'></td>
<td width='100%'><img src='/servermonitor/clear.gif' width='1' height='1' alt='' border='0'></td>
</tr>

				</table>
			</td>
		<tr>
			<td colspan='2' class='mapinfo'><a name='info'></a>
				<table cellpadding='0' cellspacing='0' border='0' width='100%' height='100%' class='mapinfo'>
					<tr>
<td colspan='2' class='miheader'><div class='miheader'>Current Map Information</div></td>
</tr>
<tr>
   <td class='miitem' valign='top'><div class='miitem'>Map Title</div></td>
   <td class='mivalue' valign='top'><div class='mivalue'>$data{maptitle}</div></td>
</tr><tr>
   <td class='miitem' valign='top'><div class='miitem'>Map Author</div></td>
   <td class='mivalue' valign='top'><div class='mivalue'>$data{Author}</div></td>
</tr><tr>
   <td class='miitem' valign='top'><div class='miitem'>Map Description</div></td>
   <td class='mivalue' valign='top'><div class='mivalue'style='text-align: justify;'>$data{Description}</div></td>
</tr>
;
if (defined $muts) {
print qq
<tr>
   <td class='miitem' valign='top'><div class='miitem'>Mutators in Use</div></td>
   <td class='mivalue' valign='top'><div class='mivalue'style='text-align: left;'>$muts</div></td>
</tr>
;
}
				
print qq				
				<tr>
<td height='100%'><img src='/servermonitor/clear.gif' width='150' height='1' alt='' border='0'></td>
<td width='100%'><img src='/servermonitor/clear.gif' width='50' height='1' alt='' border='0'></td>
</tr>
				</table>
			</td>
		</tr>
		</table>
;
}